 #include "pitches.h"

int verse1[] = {
  NOTE_C6, NOTE_C6, NOTE_G6, NOTE_G6, NOTE_A6, NOTE_A6, NOTE_G6, NOTE_F6, NOTE_F6, NOTE_E6, NOTE_E6, NOTE_D6, NOTE_D6, NOTE_C6};
  
 
 int verse2[] = {
   NOTE_G6, NOTE_G6, NOTE_F6, NOTE_F6, NOTE_E6, NOTE_E6, NOTE_D6, NOTE_G6, NOTE_G6,NOTE_F6, NOTE_F6, NOTE_E6, NOTE_E6, NOTE_D6};

// note durations: 4 = quarter note, 8 = eighth note, etc.:
int noteDurations[] = {
  4,4,4,4,4,4,2,4,4,4,4,4,4,2};



//Digital Pins


int segmentA = 1;
int segmentB = 2;
int segmentC = 5;
int segmentD = 4;
int segmentE = 3;
int segmentF = 7;
int segmentG = 6;

int digit0 = 8;
int digit1 = 0;


const int IRout = 9;
const int switchb = 10;
const int motor = 11;
const int speaker= 12;
const int LED = 13;




//Analog Pins
const int IRin = 5;  // Analog input pin that the potentiometer is attached to


int sensorValue = 0;        // value read from the pot
int switchValue =0;


int ledcount=15;
int toggle1=0;

//int IRReading=0;
//int IRAvg=0;

//int IRDelta=200;//diference in IR Values for a trigger 

int IRThreshold=1000;


unsigned long time=0;

byte segments[10] =
{
  B00111111, // 0
  B00000110, // 1
  B01011011, // 2
  B01001111, // 3
  B01100110, // 4
  B01101101, // 5
  B01111101, // 6
  B00000111, // 7
  B01111111, // 8
  B01101111  // 9
};

void setup() {

  pinMode(motor,OUTPUT);  
  pinMode(switchb,INPUT);
  pinMode(IRout,OUTPUT);
  pinMode(LED,OUTPUT);
  
  digitalWrite(motor,LOW);  
  digitalWrite(IRout,HIGH);
  
  pinMode(segmentA,OUTPUT);
  pinMode(segmentB,OUTPUT);
  pinMode(segmentC,OUTPUT);
  pinMode(segmentD,OUTPUT);
  pinMode(segmentE,OUTPUT);
  pinMode(segmentF,OUTPUT);
  pinMode(segmentG,OUTPUT);


  pinMode(digit0,OUTPUT);
  pinMode(digit1,OUTPUT);
  digitalWrite(digit0 ,HIGH);
  digitalWrite(digit1 ,HIGH);
  
  
  /*
  //average 5 IR readings for Normal
  digitalWrite(LED,HIGH);
  for (int x=0;x<5;x++)
  {
    IRReading+=analogRead(IRin);
    delay(20);   
  }
  
  IRAvg=IRReading/5;
  IRThreshold= IRAvg+IRDelta;
  
  */
  
  
  //Configure timer1 in normal mode (no PWM)
TCCR1A &= ~((1<<WGM11) | (1<<WGM10));
TCCR1B &= ~((1<<WGM12) | (1<<WGM13)) ;


  
  
  digitalWrite(LED,HIGH);
  delay(1000);
  digitalWrite(LED,LOW);
  delay(1000);
  digitalWrite(LED,HIGH);
  delay(1000);
  digitalWrite(LED,LOW);
  delay(1000);
  digitalWrite(LED,HIGH);
  delay(1000);
  digitalWrite(LED,LOW);

  
    // initialize serial communications at 9600 bps:
  //Serial.begin(9600); 
  //Serial.print("Threshold=");
  //Serial.print(IRThreshold);
  


  //Switch was left on
  if (digitalRead(switchb)==HIGH)
  {
    //Serial.print("Switch left on, turning motor\n");
    while(digitalRead(switchb)==HIGH  &&millis() < 10000)
    {
      digitalWrite(motor,HIGH);           
    }
    
  }
  
  if (digitalRead(switchb)==HIGH)
  {
    //Serial.print("Error, cannot turn switch off");
    while(1)
    {            
    }
  }
  digitalWrite(motor,LOW);           
  
  
  
}

void loop() {
  // read the analog in value:
  sensorValue = analogRead(IRin);          
  switchValue= digitalRead(switchb);
  
  // map it to the range of the analog out:

  // change the analog out value:
  // analogWrite(analogOutPin, outputValue);           

  // print the results to the serial monitor:
  //Serial.print("sensor = " );                       
  //Serial.print(sensorValue);      
  //Serial.print("\t switch = ");
  //Serial.print(switchValue);
  //Serial.print("\n");
  
  
  
  if (sensorValue>IRThreshold)
  {
    
    dispense();
    delay(1500);
    
    int numberOfDispenses=1;
    
    while ( numberOfDispenses <4 && analogRead(IRin)>1000)
    {
      dispense();
      numberOfDispenses++;
      delay(1500);      
    }
    
       
    digitalWrite(LED,HIGH); 
    
    //load the time for the count down
    ledcount=15;
    time=millis();

    //Enable the timer 
    TIMSK1 |= (1<<TOIE1);
    TCNT1=0xFF00;
    
    

    
    
    
    twinkle();
    
    
    digitalWrite(LED,LOW);
    
    //Serial.print("Minimum wait 3 seco...\n");
    delay(3000);
 
    
    
  }   

  delay(1000);                     
}


void dispense()
{
    //Serial.print("Turning on Motor...\n");

    while (digitalRead(switchb)==LOW)
    {
      digitalWrite(motor,HIGH);                 
    }

    //A little debounce
    delay(100);

    //Serial.print("Switch Activated!!\n");
    while (digitalRead(switchb)==HIGH)
    {
      digitalWrite(motor,HIGH);
    }
    //Serial.print("Turning off Motor...\n");   
    digitalWrite(motor,LOW);
  
}







void twinkle()
{
  
  // iterate over the notes of the melody:
  for (int thisNote = 0; thisNote < 14; thisNote++) {

    // to calculate the note duration, take one second 
    // divided by the note type.
    //e.g. quarter note = 1000 / 4, eighth note = 1000/8, etc.
    int noteDuration = 1000/noteDurations[thisNote];
    tone(speaker, verse1[thisNote],noteDuration);

    // to distinguish the notes, set a minimum time between them.
    // the note's duration + 30% seems to work well:
    int pauseBetweenNotes = noteDuration * 1.30;
    delay(pauseBetweenNotes);
  }
  
  
  
  
  
  for (int thisNote = 0; thisNote < 14; thisNote++) {

    // to calculate the note duration, take one second 
    // divided by the note type.
    //e.g. quarter note = 1000 / 4, eighth note = 1000/8, etc.
    int noteDuration = 1000/noteDurations[thisNote];
    tone(speaker, verse2[thisNote],noteDuration);

    // to distinguish the notes, set a minimum time between them.
    // the note's duration + 30% seems to work well:
    int pauseBetweenNotes = noteDuration * 1.30;
    delay(pauseBetweenNotes);
  }
  
  
  
  
  
  for (int thisNote = 0; thisNote < 14; thisNote++) {

    // to calculate the note duration, take one second 
    // divided by the note type.
    //e.g. quarter note = 1000 / 4, eighth note = 1000/8, etc.
    int noteDuration = 1000/noteDurations[thisNote];
    tone(speaker, verse1[thisNote],noteDuration);

    // to distinguish the notes, set a minimum time between them.
    // the note's duration + 30% seems to work well:
    int pauseBetweenNotes = noteDuration * 1.30;
    delay(pauseBetweenNotes);
  }
  
  
  
}

ISR(TIMER1_OVF_vect)
{
  //Set next iterrupt to occur in 16ms
  TCNT1=0xF000;


  if(millis()-time>1000)
  {
   time=millis();
   ledcount--;      
  }
  

  if (toggle1==0)
  {
    toggle1=1;
    int display0 = segments[ledcount%10];
    
    digitalWrite(digit0 ,LOW);
    digitalWrite(digit1 ,HIGH);
        
    digitalWrite(segmentA, bitRead(display0, 0) );
    digitalWrite(segmentB, bitRead(display0, 1) );
    digitalWrite(segmentC, bitRead(display0, 2) );
    digitalWrite(segmentD, bitRead(display0, 3) );
    digitalWrite(segmentE, bitRead(display0, 4) );
    digitalWrite(segmentF, bitRead(display0, 5) );
    digitalWrite(segmentG, bitRead(display0, 6) );        
  }
  else
  {
    toggle1=0;
    int display1 = segments[ledcount/10];
    
    digitalWrite(digit0, HIGH);
    digitalWrite(digit1, LOW);
    
    digitalWrite(segmentA, bitRead(display1, 0) );
    digitalWrite(segmentB, bitRead(display1, 1) );
    digitalWrite(segmentC, bitRead(display1, 2) );
    digitalWrite(segmentD, bitRead(display1, 3) );
    digitalWrite(segmentE, bitRead(display1, 4) );
    digitalWrite(segmentF, bitRead(display1, 5) );
    digitalWrite(segmentG, bitRead(display1, 6) );
  }
  
  
     if (ledcount<0)
   {
     //disable timer
     TIMSK1 &= ~(1<<TOIE1);
     
     //disable display
    digitalWrite(digit0 ,HIGH);
    digitalWrite(digit1 ,HIGH);
   
   }

  
}


